<?php
/**
 * Created by JetBrains PhpStorm.
 * User: jorgefonseca
 * Date: 30/08/13
 * Time: 17:54
 * To change this template use File | Settings | File Templates.
 */

namespace Financeiro\Logic\ContasPagar\ImportacaoRateio;


class Util {
    private static $classes = array();

    const MIG = 'Mig';
    const GPE = "GPE";
    const FPA = "FPA";
    const NRORG = "NRORG";

    private static $remover_invalidos = array(
                                    "ª" => "", "º" => "", "à" => "a","á" => "a","ã" => "a","â" => "a","é" => "e","ê" => "e","ì" => "i","í" => "i",
                                    "ó" => "o", "õ" => "o","ô" => "o","ú" => "u","ü" => "u","ç" => "c","À" => "A","Á" => "A","Ã" => "A","Â" => "A",
                                    "É" => "E","Ê" => "E","Í" => "I","Ó" => "O","Õ" => "O","Ô" => "O","Ù" => "U","Ú" => "U","Ü" => "U", " " => "_",
                                    "." => ""
                                );
    private static $remover = array(
                                    "ª" => "", "º" => "", "à" => "a","á" => "a","ã" => "a","â" => "a","é" => "e","ê" => "e","ì" => "i","í" => "i",
                                    "ó" => "o", "õ" => "o","ô" => "o","ú" => "u","ü" => "u","ç" => "c","À" => "A","Á" => "A","Ã" => "A","Â" => "A",
                                    "É" => "E","Ê" => "E","Í" => "I","Ó" => "O","Õ" => "O","Ô" => "O","Ù" => "U","Ú" => "U","Ü" => "U","." => ""
                                );

    /**
     *
     *
     * @param $arquivo
     * @return mixed
     */
    public static function getQtdLinhasArquivo($arquivo)
    {
        exec('wc -l ' . $arquivo, $output);
        $output = reset(explode(' ', trim(reset($output))));
        return $output;
    }

    /**
     * Prepara nome da classe
     *
     * @param $tabela
     * @return string
     *
     * @author leonardocarvalho 04/12/2013
     *
     */
    public static function normalizeNameClass($tabela) {
        if(!isset(self::$classes[$tabela])){
            $classParts   = explode("_", $tabela);
            $nomeDaClasse = "";

            foreach ($classParts as $part) {
                $part = ($part == self::GPE || $part == self::FPA) ? null : $part;
                $nomeDaClasse = ucfirst(strtolower($part));
            }
            self::$classes[$tabela] = self::MIG . $nomeDaClasse;
        }
        return self::$classes[$tabela];

    }

    /**
     * @param $tabela
     * @return mixed
     *
     * @author leonardocarvalho
     */
    public static function retornaPrimaryKey($tabela) {

        $tabela = self::normalizeNameClass($tabela);
        $primaryKey = new $tabela();
        $primaryKey = $primaryKey->getPrimaryKey();

        foreach ($primaryKey as $key => $value) {
            if ($value === self::NRORG) {
                unset($primaryKey[$key]);
            }
        }

        if (is_array($primaryKey)) {
            sort($primaryKey);
            return $primaryKey[0];
        } else {
            return $primaryKey;
        }

    }

    /**
     * @param $path
     *
     * @author leonardocarvalho
     */
    public static function verificaDiretorio($path) {

        if (!file_exists($path)) {
            mkdir($path, 0777, true);
        }

        return $path;

    }

    /**
     * executa arquivos .SQL
     *
     * @param $path
     * @throws \Exception
     *
     * @author leonardocarvalho
     */
    public static function executaSQL($path) {

        $progressBar = new \Importacao\Logic\Util\BarraProgressoCli(
            'Criando Ocupações', count(file($path))
        );

        // Pega Cada Linha e Joga na Matriz $arquivo
        $handle = @fopen($path, "r");
        $count = 0;
        // Executa um Loop Retornando cada valor da matriz $sql, que está em $linha, ou seja cada valor do $linha é uma instrução sql diferente
        while (!feof($handle)) {
            try{
                $linha = fgets($handle, 4096);
                if ($linha) {
                    $linha = str_replace(";", "", $linha);
                    \Setforms2\Runtime\Connection::getInstance()->execute($linha);
                }
            }catch(\Exception $e){
                tk_warning($e->getMessage());
                throw $e;
            }
            $progressBar->showStatus($count + 1);
            $count++;
        }
        fclose($handle);
        $progressBar->finish();

    }

    /**
     * retorna todos os arquivos de um diretório
     *
     * @param $directoryPath
     * @return bool
     *
     * @author leonardocarvalho
     */
    private static function getArquivosDiretorio($directoryPath) {

        $ignorar = array('..', '.');
        $arquivos = array_diff(scandir($directoryPath), $ignorar);

        return sort($arquivos);

    }

    /**
     * @param $tablename
     * @return string
     *
     * @author leonardocarvalho
     */
    public static function novoCodigo($tablename) {

        $primaryKey = self::retornaPrimaryKey($tablename);
        $query = "SELECT MAX($primaryKey) FROM $tablename";
        $result = \Setforms2\Runtime\Connection::getInstance()->execute($query);
        $cdoperador = $result->fetchColumn(0) + 1;

        return $cdoperador;

    }

    public static function removeCaracteresInvalidos($str){
        return strtr($str, self::$remover_invalidos);
    }

    public static function removeCaracteres($str){
        return strtr($str, self::$remover);
    }

    public static function validaMesCompetencia($mescompetencia, $anocompetencia){

        $mescompetencia = trim($mescompetencia);
        $anocompetencia = trim($anocompetencia);

        if (strlen($mescompetencia) < 2){
            return '01/'.'0'.$mescompetencia.'/'.$anocompetencia;
        } else {
            return '01/'.$mescompetencia.'/'.$anocompetencia;
        }

    }

    public static function getErrorCodeOracle($exception) {
        $result = null;
        preg_match("/ORA-\d{5}/", $exception, $result);

        return $result[0];
    }

}