<?php
namespace Folha\Entities;

use Geral\Entities\Base\Tiporelaciona;
use HCM\Util\DateUtil;
use Importacao\Logic\Integracao\ProjetoImportacao;

class MigRelacionaparc extends Base\MigRelacionaparc
{

    /**
     * @param $nrrelacionaparc
     * @return \Folha\Entities\MigRelacionaparc
     */
    public function setNrrelacionaparc ($nrrelacionaparc) {
        $nrrelacionaparc = \Importacao\Logic\Validacoes::verificaChaveDuplicada('RELACIONAPARC', 'NRRELACIONAPARC', ProjetoImportacao::getNrorg(), $nrrelacionaparc);
        $this->nrrelacionaparc = $nrrelacionaparc;
    }

    /**
     * @param $nrparcnegocio
     * @return \Folha\Entities\MigRelacionaparc
     */
    public function setNrparcnegocio ($nrparcnegocio) {
        $nrparcnegocio = \Importacao\Logic\Validacoes::verificaChaveMae('PARCNEGOCIO', 'NRPARCNEGOCIO', ProjetoImportacao::getNrorg(), $nrparcnegocio);
        $this->nrparcnegocio = $nrparcnegocio;
    }

    /**
     * @param $nrparcnegrelac
     * @return \Folha\Entities\MigRelacionaparc
     */
    public function setNrparcnegrelac ($nrparcnegrelac) {
        $nrparcnegrelac = \Importacao\Logic\Validacoes::verificaChaveMae('PARCNEGOCIO', 'NRPARCNEGOCIO', ProjetoImportacao::getNrorg(), $nrparcnegrelac);
        $this->nrparcnegrelac = $nrparcnegrelac;
    }

    /**
     * @param $nrtiporelaciona
     * @throws \Exception
     * @return \Folha\Entities\MigRelacionaparc
     */
    public function setNrtiporelaciona ($nrtiporelaciona) {
        if (!empty($nrtiporelaciona)) {
            $nrorg = ProjetoImportacao::getNrorgPadrao();
            $tiporelaciona = \Geral\Entities\Tiporelaciona::getObjectByWhere('NRTIPORELACIONA = ? AND NRORG = ?', array($nrtiporelaciona, $nrorg));

            if (is_object($tiporelaciona)) {
                $this->nrtiporelaciona = $nrtiporelaciona;
            } else {
                throw new \Exception("O código de Tipo de Relacionamento '$nrtiporelaciona' não foi encontrado.");
            }
        } else {
            throw new \Exception("O código de Tipo de Relacionamento '$nrtiporelaciona' não foi encontrado.");
        }
    }

    /**
     * @param mixed $dtinclusao
     * @throws \Exception
     * @return \Folha\Entities\Base|void
     */
    public function setDtinclusao($dtinclusao)
    {
        if (!preg_match("/\d{2}\/\d{2}\/\d{4}/", $dtinclusao)) {
            throw new \Exception("Data '$dtinclusao' com formato inválido ou em branco.");
        }

        if (!($dtinclusao instanceof \DateTime)) {
            $dtinclusao = DateUtil::getDataDeString($dtinclusao);
        }

        $this->dtinclusao = $dtinclusao;
    }

    /**
     * @param mixed $dtultatu
     * @throws \Exception
     * @return \Folha\Entities\Base|void
     */
    public function setDtultatu($dtultatu)
    {
        if (!preg_match("/\d{2}\/\d{2}\/\d{4}/", $dtultatu)) {
            throw new \Exception("Data '$dtultatu' com formato inválido ou em branco.");
        }

        if (!($dtultatu instanceof \DateTime)) {
            $dtultatu = DateUtil::getDataDeString($dtultatu);
        }

        $this->dtultatu = $dtultatu;
    }

}