/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_ALIQIMPFIS                                               */
/* Tabela : ALIQIMPFIS                                                        */
/*                                                                            */
/* Criao:                                                                   */
/* 29/11/2004 - Ronaldo Amaral Costa                                          */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_ALIQIMPFIS'  and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_ALIQIMPFIS
GO

CREATE TRIGGER DTULTATU_ALIQIMPFIS
ON ALIQIMPFIS
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'ALIQIMPFIS', CDFILIAL, 'CDFILIAL='+ CDFILIAL+';'+
                'CDPRODUTO='+CDPRODUTO+';'+'CDIMPOSTO='+CDIMPOSTO+';', CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108)) FROM DELETED)
   END
   ELSE BEGIN
      UPDATE ALIQIMPFIS
      SET DTULTATUALIF = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
      FROM INSERTED
      WHERE (ISNULL(ALIQIMPFIS.CDFILIAL,0)     = ISNULL(INSERTED.CDFILIAL,0))     AND
            (ISNULL(ALIQIMPFIS.CDPRODUTO,0)    = ISNULL(INSERTED.CDPRODUTO,0))    AND
            (ISNULL(ALIQIMPFIS.CDIMPOSTO,0)    = ISNULL(INSERTED.CDIMPOSTO,0))  ;
   END;
END;
GO


UPDATE ALIQIMPFIS SET DTULTATUALIF = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108)) WHERE DTULTATUALIF IS NULL
GO

IF EXISTS(SELECT * FROM sysobjects O
          WHERE
            o.name = 'DEFAULT_DTULTATUALIF' and
            type = 'D')
   ALTER TABLE ALIQIMPFIS DROP CONSTRAINT DEFAULT_DTULTATUALIF
GO

ALTER TABLE ALIQIMPFIS ADD CONSTRAINT DEFAULT_DTULTATUALIF
DEFAULT CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
FOR DTULTATUALIF
GO

-- VERSAO --
EXEC ATUVEROBJ 'DTULTATU_ALIQIMPFIS','4.11.194';
GO

